function I = floyd(I)
[M, N] = size(I);
for i=1:M
    for j=1:N
        old = I(i,j);
        new = round(I(i,j));
        I(i,j) = new;
        err = old - new;
        if(j < N)
            I(i, j+1) = I(i, j+1) + err*7/16;
        end
        if(i<M)
            if j>1
                I(i+1,j-1) = I(i+1,j-1) + err*3/16;
            end
            I(i+1,j) = I(i+1,j) + err*5/16;
            if (j<N)
                I(i+1,j+1) = I(i+1,j+1) + err*1/16;
            end
        end
    end
end